﻿using System;
using System.Collections.Generic;
using System.Linq;
using CombatExtended.Compatibility;
using RimWorld;
using UnityEngine;
using Verse;
using Verse.AI;
using Verse.Sound;
using CombatExtended;

namespace Mgaazines
{

	public class NadeComp : ThingComp
	{

		

		public bool RightGun = false;

		public int deed;
		public int beed;

		public NadeCompProps Props => (NadeCompProps)this.props;
		
		public override void CompTick()
		{
		
			deed++;
			if(deed == 1)
			{
				Pawn lul = this.parent.Position.GetFirstThing(this.parent.Map, ThingDefOf.Human) as Pawn;
				Mgaazines.Verb_ShootCE pop = lul.equipment.Primary.TryGetComp<CompEquippable>().PrimaryVerb as Mgaazines.Verb_ShootCE;
				
				if (pop.EquipmentSource.TryGetComp<AndrzejDuda>() != null)
				{
					pop.Dupa2(this.parent as ProjectileCE);
					this.parent.AllComps.Add(ThingMaker.MakeThing(Doodoo.BlankAmmoTwo).TryGetComp<CompExplosiveCE>());
					
					
					

				}
				
				
			}

			

			


			



			base.CompTick();
			

		}
		public void Dupa(Mgaazines.Verb_ShootCE poop)
		{
			
			this.RightGun = true;
		}
		public void Indirect()
		{
			ProjectilePropertiesCE ppoop = this.parent.def.projectile as ProjectilePropertiesCE;
			ppoop.flyOverhead = true;
			ppoop.gravityFactor = 5;
			//ppoop.speed = 0;
			
		}
		public void Direct()
		{
			ProjectilePropertiesCE ppoop = this.parent.def.projectile as ProjectilePropertiesCE;
			ppoop.flyOverhead = false;
			//ppoop.gravityFactor = 0;
			ppoop.speed = 185;
			
		}
		public override void Initialize(CompProperties props)
		{
			deed = 0;
			beed = 0;
			//this.parent.def = Doodoo.BlankThree;
			base.Initialize(props);

		}

	}

	public class NadeCompProps : CompProperties
	{

		public int placek;
		public NadeCompProps()
		{
			this.compClass = typeof(NadeComp);
		}

		public NadeCompProps(Type compClass) : base(compClass)
		{
			this.compClass = compClass;
		}

	}
	public class AndrzejDuda : CompRangedGizmoGiver
	{
		public bool GizmoDooDoo = true;

		public bool NadeIsScrewedOn;
		

		public Granatatuj Props => (Granatatuj)this.props;
		public override IEnumerable<Gizmo> CompGetGizmosExtra()
		{
			CompAmmoUser lmao = this.parent.TryGetComp<CompAmmoUser>();
			
			if (lmao.CurrentAmmo == Doodoo.Ammo_556x45mm_Blank)
			{
				yield return new IndirectGizmo(this)
				{

				};
			}
			
			

			yield break;
		}


	}

	public class Granatatuj : CompProperties
	{

		public int placek;
		public Granatatuj()
		{
			this.compClass = typeof(AndrzejDuda);
		}

		public Granatatuj(Type compClass) : base(compClass)
		{
			this.compClass = compClass;
		}

	}
	[StaticConstructorOnStartup]
	public class IndirectGizmo : Command
	{
		public IndirectGizmo(AndrzejDuda Duda)
		{
			bipod = Duda;
			bool flag = this.bipod.GizmoDooDoo;
			if (flag)
			{
				this.defaultLabel = this.labelStart;
				Mgaazines.Verb_ShootCE pope = Duda.parent.TryGetComp<CompEquippable>().PrimaryVerb as Mgaazines.Verb_ShootCE;
				if(pope.lmao != null)
				{
					pope.lmao.TryGetComp<NadeComp>().Indirect();
				}
				
				this.defaultDesc = this.descriptionStart;
				this.icon = IndirectGizmo.startIcon;
			}
			else
			{

				this.defaultLabel = this.labelStop;
				Mgaazines.Verb_ShootCE pope = Duda.parent.TryGetComp<CompEquippable>().PrimaryVerb as Mgaazines.Verb_ShootCE;
				if (pope.lmao != null)
				{
					pope.lmao.TryGetComp<NadeComp>().Direct();
				}
				
				this.defaultDesc = this.descriptionStop;
				this.icon = IndirectGizmo.stopIcon;

			}
		}

		
		public override void ProcessInput(Event ev)
		{
			base.ProcessInput(ev);
			bool flag = this.bipod.GizmoDooDoo;
			if (flag)
			{
				this.bipod.GizmoDooDoo = false;
			}
			else
			{
				this.bipod.GizmoDooDoo = true;
				
			}
		}


		public static Texture2D stopIcon = ContentFinder<Texture2D>.Get("Things/Explosive_south", true);


		public static Texture2D startIcon = ContentFinder<Texture2D>.Get("Things/Explosive_south", true);




		public AndrzejDuda bipod;


		public string labelStart = "Indirect fire";


		public string descriptionStart = "Placeholder";


		public string labelStop = "Direct fire";


		public string descriptionStop = "Placeholder";
	}
	public class NadeMounting : JobDriver
	{
		private ThingWithComps weapon
		{
			get
			{
				return base.TargetThingA as ThingWithComps;
			}
		}

		private const TargetIndex GunToUnjam = TargetIndex.A;
		public override bool TryMakePreToilReservations(bool errorOnFailed)
		{
			//return true;	
			return this.pawn.Reserve(this.job.GetTarget(GunToUnjam), this.job, 1, -1, null);
		}
		public AndrzejDuda granatComp
		{
			get
			{
				return this.weapon.TryGetComp<AndrzejDuda>();
			}
		}
		protected override IEnumerable<Toil> MakeNewToils()
		{
			List<Thing> lupo = this.pawn.GetComp<CompInventory>().container.ToList<Thing>();
			Thing poop = lupo.Find(thing => thing.def == Doodoo.ApavForty);
			if (poop != null)
			{
				Toil toil = Toils_General.Wait(30);
				toil.AddFinishAction(delegate
				{
					granatComp.NadeIsScrewedOn = true;
					if (poop.stackCount > 0)
					{
						--poop.stackCount;
					}
					else
					{
						poop.Destroy();
					}

				});
				yield return toil;
			}
			else
			{
				Toil toil = null;
				yield return toil;
			}
			
			
			
			
			

			
			

			
		}


	}
	[DefOf]
	public static class Doodoo
	{
		static Doodoo()
		{
			DefOfHelper.EnsureInitializedInCtor(typeof(Doodoo));
		}
		public static ThingDef BlankAmmo;
		public static ThingDef BlankThree;
		public static ThingDef BlankAmmoTwo;
		public static ThingDef Blut;
		public static JobDef NadeJob;
		public static ThingDef ApavForty;
		public static AmmoDef Ammo_556x45mm_Blank;
	}
}
